/*
								+----------------------------------+
								|                                  |
								|  ***  OpenGL image binding  ***  |
								|                                  |
								|   Copyright  -tHE SWINe- 2007   |
								|                                  |
								|           ImageBind.h            |
								|                                  |
								+----------------------------------+
*/

#ifndef __IMAGE_BIND_INCLUDED
#define __IMAGE_BIND_INCLUDED

/**
 *	bool Bind_SrcImage(CGLState *p_state, ImageStruct *p_image,
 *		TImageStructInfo **p_get_image_info = 0)
 *		- binds image as source to active texturing unit
 *		- p_state is OpenGL state cache, p_image is image in question
 *		- in case p_get_image_info is not 0, image info is copied there
 *		- returns true on success, false on failure
 */
bool Bind_SrcImage(CGLState *p_state, ImageStruct *p_image,
	TImageStructInfo **p_get_image_info = 0);

/**
 *	bool Release_SrcImage(CGLState *p_state, ImageStruct *p_image)
 *		- releases source image
 *		- p_state is OpenGL state cache, p_image is image in question
 */
bool Release_SrcImage(CGLState *p_state, ImageStruct *p_image);

/**
 *	CGLNamedRenderBuffer_FBO *p_Bind_Texture_Raw(CGLState *p_state, CGLTexture_2D *p_texture)
 *		- binds texture p_texture for rendering
 *		- p_state is OpenGL state cache
 *		- returns render buffer which is bound to p_texture or 0 in case error occured
 */
CGLNamedRenderBuffer_FBO *p_Bind_Texture_Raw(CGLState *p_state, CGLTexture_2D *p_texture);

/**
 *	void Release_Texture_Raw(CGLNamedRenderBuffer_FBO *p_render_buffer)
 *		- ends rendering to p_render_buffer and releases bound texture
 */
void Release_Texture_Raw(CGLNamedRenderBuffer_FBO *p_render_buffer);

/**
 *	CGLNamedRenderBuffer_FBO *p_Bind_DestImage(CGLState *p_state, ImageStruct *p_image)
 *		- binds image as destination, returns render buffer for rendering to image's texture
 *		- p_state is OpenGL state cache, p_image is image in question
 *		- returns render buffer on success, 0 on failure
 */
CGLNamedRenderBuffer_FBO *p_Bind_DestImage(CGLState *p_state, ImageStruct *p_image);

/**
 *	bool Release_DestImage(CGLState *p_state, ImageStruct *p_image,
 *		CGLNamedRenderBuffer_FBO *p_render_buffer)
 *		- ends rendering to p_image, returns p_render_buffer
 *		- p_state is OpenGL state cache
 *		- returns true on success, false on failure
 */
bool Release_DestImage(CGLState *p_state, ImageStruct *p_image,
	CGLNamedRenderBuffer_FBO *p_render_buffer);

#endif //__IMAGE_BIND_INCLUDED
