/*
								+----------------------------------+
								|                                  |
								| *** DigiLib OpenGL extension *** |
								|                                  |
								|   Copyright  -tHE SWINe- 2007   |
								|                                  |
								|          ShadersSrc.cpp          |
								|                                  |
								+----------------------------------+
*/

#if defined(_MSC_VER) && !defined(__MWERKS__)
#pragma warning(disable:4786)
#endif
// disable warning C4786 "identifier was truncated to '255' characters in the debug information"

#include <vector>
#include "../berLame_src/CallStack.h"
#ifdef WIN32
#include <windows.h>
#endif
#define GL_GLEXT_LEGACY
#include <GL/gl.h>
#include "../berLame_src/OpenGL20.h"
#include <algorithm>
#include <stdlib.h>
#include <string.h>
#include "../berLame_src/OpenGLDrv.h"
#include "../berLame_src/OpenGLState.h"
#include "../berLame_src/Texture.h"
#include "../berLame_src/RenderBuffer2.h"
#include "../berLame_src/Shader2.h"
#include "../berLame_src/ShaderSys.h"
#include "../berLame_src/VertexBufferObject.h"
#include "Shader_Manager.h"

#if defined(_MSC_VER) && !defined(__MWERKS__) && !defined(for)
#define for if(0) {} else for
#endif

/**
 *	class CAdHocShaderInfo
 *		- nice class with simple constructor for defining shaders
 */
/*class CAdHocShaderInfo : public TShaderInfo {
	TShaderInfo::TShader m_t_high;

public:
	CAdHocShaderInfo(const char *p_s_shader_name, bool b_fragment_shader,
		const char *p_s_source_code, const char *p_s_sampler_names = 0)
	{
		p_s_name = (char*)p_s_shader_name;
		b_fragment = b_fragment_shader; // vertex or fragment?
		b_shader_target = true; // "shader", not "program"
		p_low = 0; // no program
		p_high = &m_t_high; // my shader

		m_t_high.p_s_source_code = (char*)p_s_source_code;
		m_t_high.n_sampler_num = 0;
		if(p_s_sampler_names) {
			for(const char *p_s_sampler = p_s_sampler_names; p_s_sampler;
			   p_s_sampler = (strchr(p_s_sampler, '|'))? strchr(p_s_sampler, '|') + 1 : 0)
				++ m_t_high.n_sampler_num;
			// count samplers

			m_t_high.p_sampler = new TShaderInfo::TShader::TSamplerInfo[m_t_high.n_sampler_num];
			_ASSERTE(m_t_high.p_sampler);
			// alloc samplers

			m_t_high.n_sampler_num = 0;
			for(const char *p_s_sampler = p_s_sampler_names; p_s_sampler;
			   p_s_sampler = (strchr(p_s_sampler, '|'))? strchr(p_s_sampler, '|') + 1 : 0) {
				char *p_s_str;
				if(strchr(p_s_sampler, '|')) {
					int n_size = strchr(p_s_sampler, '|') - p_s_sampler;
					if(p_s_str = new char[n_size + 1]) {
						strncpy(p_s_str, p_s_sampler, n_size);
						p_s_str[n_size] = 0;
					}
				} else
					p_s_str = p_s_Alloc(p_s_sampler);
				_ASSERTE(p_s_str);
				// get a single sampler name

				m_t_high.p_sampler[m_t_high.n_sampler_num].p_s_name = p_s_str;
				m_t_high.p_sampler[m_t_high.n_sampler_num].n_resource_index = m_t_high.n_sampler_num;
				// assign samplers

				++ m_t_high.n_sampler_num;
			}
			// assign sampler names and indices
		} else
			m_t_high.p_sampler = 0;
	}

	~CAdHocShaderInfo()
	{
		m_t_high.p_s_source_code = 0;
		// don't want to be deleted by TShaderInfo::TShader destructor as it's static data

		p_s_name = 0;
		p_high = 0;
		// don't want them to be deleted by TShaderInfo destructor as they are static data
	}
};*/ // don't need this anymore

TShaderInfo my_test_shader("my_test_shader", true, "void main()\n{\ngl_FragColor = vec4(1, 0, 0, 1);\n// test red output\n}\n");
// dummy test shader (const red output)

TShaderInfo my_test_shader2("my_test_shader2", true,
	"uniform sampler2D operand1, operand2;\n"
	"void main()\n"
	"{\n"
	"    gl_FragColor = texture2D(operand1, gl_TexCoord[0].xy) - texture2D(operand2, gl_TexCoord[0].xy);\n"
	"    // test red output\n"
	"}\n", "operand1|operand2");
// test shader 2 (subtracts two operands)

TShaderInfo greyscale_shader("greyscale_shader", true,
	"uniform sampler2D operand1;\n"
	"void main()\n"
	"{\n"
	"    vec4 v_src = texture2D(operand1, gl_TexCoord[0].xy);\n"
	"    float f_grey = dot(v_src.xyz, vec3(.299, .587, .144));\n"
	"    gl_FragColor = vec4(f_grey, f_grey, f_grey, v_src.w);\n"
	"}\n");
// greyscale shader

TShaderInfo color_matrix_shader("color-matrix_shader", true,
	"uniform sampler2D operand1;\n"
	"uniform mat4 matrix;\n"
	"void main()\n"
	"{\n"
	"    gl_FragColor = texture2D(operand1, gl_TexCoord[0].xy) * matrix;\n"
	"}\n");
// color matrix shader (doesn't necessarily lead to alpha = 1)

TShaderInfo threshold_shader("threshold_shader", true,
	"uniform sampler2D operand1;\n"
	"uniform float f_thresh;\n"
	"void main()\n"
	"{\n"
	"    gl_FragColor = step(f_thresh, texture2D(operand1, gl_TexCoord[0].xy));\n"
	"}\n");
// threshold shader (doesn't necessarily lead to alpha = 1)

TShaderInfo invert_shader("invert_shader", true,
	"uniform sampler2D operand1;\n"
	"void main()\n"
	"{\n"
	"    gl_FragColor = vec4(1, 1, 1, 1) - texture2D(operand1, gl_TexCoord[0].xy);\n"
	"}\n");
// invert shader (doesn't lead to alpha = 1)

TShaderInfo mult_shader("mult_shader", true,
	"uniform sampler2D operand1, operand2;\n"
	"void main()\n"
	"{\n"
	"    gl_FragColor = texture2D(operand1, gl_TexCoord[0].xy) * texture2D(operand2, gl_TexCoord[1].xy);\n"
	"}\n", "operand1|operand2");
// multiply shader (might output FP specials when rendered to float texture; doesn't necessarily lead to alpha = 1)

TShaderInfo mult_cmplx2_shader("mult_cmplx2_shader", true,
	"uniform sampler2D operand1, operand2;\n"
	"void main()\n"
	"{\n"
	"    vec2 v_src1 = texture2D(operand1, gl_TexCoord[0].xy).xw;\n" // re = R, im = A
	"    vec3 v_src2; v_src2.xy = texture2D(operand2, gl_TexCoord[1].xy).xw;\n" // cmplx1 * cmplx2 = re1 * re2 - im1 * im2 + j(im1 * re2 + im2 * re1)
	"    v_src2.z = -v_src2.y;\n" // put -im2 to v_src2.z
	"    gl_FragColor = vec2(dot(v_src1, v_src2.xz), dot(v_src1, v_src2.yx)).xxxy;\n"
	"}\n", "operand1|operand2");
// complex-by-complex multiply shader (might output FP specials when rendered to float texture; doesn't necessarily lead to alpha = 1)

TShaderInfo mult_cmplx_re_shader("mult_cmplx_re_shader", true,
	"uniform sampler2D operand1, operand2;\n"
	"void main()\n"
	"{\n"
	"    vec2 v_src1 = texture2D(operand1, gl_TexCoord[0].xy).xw;\n" // re = R, im = A
	"    float f_src2 = texture2D(operand2, gl_TexCoord[1].xy).x;\n" // purely real
	"    gl_FragColor = (v_src1 * f_src2).xxxy;\n"
	"}\n", "operand1|operand2");
// complex-by-real multiply shader (might output FP specials when rendered to float texture; doesn't necessarily lead to alpha = 1)

TShaderInfo divide_shader("divide_shader", true,
	"uniform sampler2D operand1, operand2;\n"
	"void main()\n"
	"{\n"
	"    gl_FragColor = texture2D(operand1, gl_TexCoord[0].xy) / texture2D(operand2, gl_TexCoord[1].xy);\n"
	"}\n", "operand1|operand2");
// divide shader (might output FP specials when rendered to float texture; doesn't necessarily lead to alpha = 1)

TShaderInfo divide_cmplx2_shader("divide_cmplx2_shader", true,
	"uniform sampler2D operand1, operand2;\n"
	"void main()\n"
	"{\n"
	"    vec2 v_src1 = texture2D(operand1, gl_TexCoord[0].xy).xw;\n" // re = R, im = A
	"    vec3 v_src2; v_src2.xy = texture2D(operand2, gl_TexCoord[1].xy).xw;\n" // cmplx1 / cmplx2 = ((re1 * re2 + im1 * im2) + j(im1 * re2 - im2 * re1)) / (re2 * re2 + im2 * im2)
	"    v_src2.z = -v_src2.y;\n" // put -im2 to v_src2.z
	"    gl_FragColor = (vec2(dot(v_src1, v_src2.xy), dot(v_src1, v_src2.zy)) / dot(v_src2.xy, v_src2.xy)).xxxy;\n"
	"}\n", "operand1|operand2");
// complex-by-complex divide shader (might output FP specials when rendered to float texture; doesn't necessarily lead to alpha = 1)

TShaderInfo divide_cmplx_re_shader("divide_cmplx_re_shader", true,
	"uniform sampler2D operand1, operand2;\n"
	"void main()\n"
	"{\n"
	"    vec2 v_src1 = texture2D(operand1, gl_TexCoord[0].xy).xw;\n" // re = R, im = A
	"    float f_src2 = texture2D(operand2, gl_TexCoord[1].xy).x;\n" // cmplx1 / re2 = ((re1 * re2) + j(im1 * re2)) / (re2 * re2) = re1 / re2 + j(im1 / re2)
	"    gl_FragColor = (v_src1 / f_src2).xxxy;\n"
	"}\n", "operand1|operand2");
// complex-by-real divide shader (might output FP specials when rendered to float texture; doesn't necessarily lead to alpha = 1)

TShaderInfo divide_re_cmplx_shader("divide_re_cmplx_shader", true,
	"uniform sampler2D operand1, operand2;\n"
	"void main()\n"
	"{\n"
	"    float f_src1 = texture2D(operand1, gl_TexCoord[0].xy).x;\n" // re = R, im = A
	"    vec3 v_src2; v_src2.xy = texture2D(operand2, gl_TexCoord[1].xy).xw;\n" // re1 / cmplx2 = ((re1 * re2) - j(re1 * im2)) / (re2 * re2 + im2 * im2)
	"    v_src2.z = -v_src2.y;\n" // put -im2 to v_src2.z
	"    gl_FragColor = (v_src2.xz * (f_src1 / dot(v_src2.xy, v_src2.xy))).xxxy;\n"
	"}\n", "operand1|operand2");
// real-by-complex divide shader (might output FP specials when rendered to float texture; doesn't necessarily lead to alpha = 1)

TShaderInfo subtract_shader("subtract_shader", true,
	"uniform sampler2D operand1, operand2;\n"
	"void main()\n"
	"{\n"
	"    gl_FragColor = texture2D(operand1, gl_TexCoord[0].xy) - texture2D(operand2, gl_TexCoord[1].xy);\n"
	"}\n", "operand1|operand2");
// subtract shader (doesn't lead to alpha = 1)

TShaderInfo blend_shader("blend_shader", true,
	"uniform sampler2D operand1, operand2;\n"
	"uniform float f_bias;\n"
	"void main()\n"
	"{\n"
	"    vec4 v_color2 = texture2D(operand2, gl_TexCoord[1].xy);\n"
	"    gl_FragColor = v_color2 + (texture2D(operand1, gl_TexCoord[0].xy) - v_color2) * f_bias;\n"
	"}\n", "operand1|operand2");
// blend shader; contains single weight to mix between sources (doesn't necessarily lead to alpha = 1)

TShaderInfo blend_shader2("blend_shader2", true,
	"uniform sampler2D operand1, operand2;\n"
	"uniform float f_weight1, f_weight2;\n"
	"void main()\n"
	"{\n"
	"    gl_FragColor = texture2D(operand1, gl_TexCoord[0].xy) * f_weight1 +\n"
	"        texture2D(operand2, gl_TexCoord[1].xy) * f_weight2;\n"
	"}\n", "operand1|operand2");
// blend shader2; contains two weights (doesn't necessarily lead to alpha = 1)

TShaderInfo log_shader("log_shader", true,
	"uniform sampler2D operand1;\n"
	"void main()\n"
	"{\n"
	"    gl_FragColor = log(1.0 + texture2D(operand1, gl_TexCoord[0].xy));\n"
	"}\n");
// natural logarithm shader (doesn't lead to alpha = 1)

TShaderInfo sqrt_shader("sqrt_shader", true,
	"uniform sampler2D operand1;\n"
	"void main()\n"
	"{\n"
	"    gl_FragColor = sqrt(texture2D(operand1, gl_TexCoord[0].xy));\n"
	"}\n");
// square root shader (doesn't lead to alpha = 1)

TShaderInfo exp_shader("exp_shader", true,
	"uniform sampler2D operand1;\n"
	"void main()\n"
	"{\n"
	"    gl_FragColor = exp(texture2D(operand1, gl_TexCoord[0].xy)) - 1.0;\n"
	"}\n");
// exponential shader (doesn't lead to alpha = 1)

TShaderInfo pow_shader("pow_shader", true,
	"uniform sampler2D operand1;\n"
	"uniform float f_power;\n"
	"void main()\n"
	"{\n"
	"    gl_FragColor = pow(texture2D(operand1, gl_TexCoord[0].xy),\n"
	"        vec4(f_power, f_power, f_power, f_power));\n"
	"}\n");
// power shader (power of source to constant; doesn't lead to alpha = 1)

TShaderInfo abs_shader("abs_shader", true,
	"uniform sampler2D operand1;\n"
	"void main()\n"
	"{\n"
	"    gl_FragColor = abs(texture2D(operand1, gl_TexCoord[0].xy));\n"
	"}\n");
// absolute value shader (power of source to constant; doesn't lead to alpha = 1)

TShaderInfo scale_shader("scale_shader", true,
	"uniform sampler2D operand1;\n"
	"uniform float f_scale, f_bias;\n"
	"void main()\n"
	"{\n"
	"    gl_FragColor = vec4(f_bias, f_bias, f_bias, f_bias) +\n"
	"        texture2D(operand1, gl_TexCoord[0].xy) * f_scale;\n"
	"}\n");
// scale / bias shader (doesn't lead to alpha = 1)

TShaderInfo point_min_shader("point_min_shader", true,
	"uniform sampler2D operand1, operand2;\n"
	"void main()\n"
	"{\n"
	"    gl_FragColor = min(texture2D(operand1, gl_TexCoord[0].xy),\n"
	"        texture2D(operand2, gl_TexCoord[1].xy));\n"
	"}\n", "operand1|operand2");
// point-wise min shader; contains two weights (doesn't necessarily lead to alpha = 1)

TShaderInfo point_max_shader("point_max_shader", true,
	"uniform sampler2D operand1, operand2;\n"
	"void main()\n"
	"{\n"
	"    gl_FragColor = max(texture2D(operand1, gl_TexCoord[0].xy),\n"
	"        texture2D(operand2, gl_TexCoord[1].xy));\n"
	"}\n", "operand1|operand2");
// point-wise max shader; contains two weights (doesn't necessarily lead to alpha = 1)

TShaderInfo ps_calc_shader("ps_calc_shader", false,
	"uniform int n_image_w, n_image_h;\n"
	"varying vec4 v_pixel_size;\n" // pixel size in texture coordinates; dx, -dx, dy, 0
	"void main()\n"
	"{\n"
	"    gl_Position = ftransform();\n"
	"    gl_TexCoord[0] = gl_MultiTexCoord0;\n"
	"    v_pixel_size = vec4(1.0 / float(n_image_w), 0, 1.0 / float(n_image_h), 0);\n"
	"    v_pixel_size.y = -v_pixel_size.x;\n"
	"    gl_TexCoord[0].xy = gl_MultiTexCoord0.xy;\n"
	"    gl_TexCoord[0].zw = gl_MultiTexCoord0.xy + v_pixel_size.xz * .5;\n"
	"}\n");

TShaderInfo bicubic_shader("bicubic_shader", true,
	"uniform sampler2D op1;\n"
	"varying vec4 v_pixel_size;\n" // needs ps_calc_shader to fill this
	"const float A = -.75;\n" // spline tension
	"\n"
	"vec2 v_Weight_0to1(vec2 x)\n" // first cubic (parallel for two values at once)
	"{\n"
	"    return ((A + 2.0) * x - (A + 3.0)) * x * x + 1.0;\n"
	"}\n"
	"\n"
	"vec2 v_Weight_1to2(vec2 x)\n" // second cubic (parallel for two values at once)
	"{\n"
	"    return ((A * x - 5.0 * A) * x + 8.0 * A) * x - 4.0 * A;\n"
	"}\n"
	"\n"
	"void main()\n"
	"{\n"
	"    vec2 v_frac_tc = mod(gl_TexCoord[0].xy, v_pixel_size.xz);\n"
	"    vec2 v_tc = gl_TexCoord[0].zw - v_frac_tc;\n"
	"\n"
	"    vec4 v_sam00 = texture2D(op1, v_tc - v_pixel_size.xz);\n"	// -dt, -dt
	"    vec4 v_sam10 = texture2D(op1, v_tc - v_pixel_size.wz);\n"	//   0, -dt
	"\n"
	"    vec4 v_pixel_size2 = v_pixel_size * 2.0;\n"
	"    v_frac_tc /= v_pixel_size.xz;\n"
	"\n"
	"    vec4 v_sam20 = texture2D(op1, v_tc - v_pixel_size.yz);\n"	//  dt, -dt
	"    vec4 v_sam30 = texture2D(op1, v_tc + vec2(v_pixel_size2.x, -v_pixel_size.z));\n" // 2dt, -dt ---
	"\n"
	"    vec2 v_weight_x12 = v_Weight_0to1(vec2(v_frac_tc.x, 1.0 - v_frac_tc.x));\n"
	"\n"
	"    vec4 v_sam01 = texture2D(op1, v_tc + v_pixel_size.yw);\n"	// -dt,   0
	"    vec4 v_sam11 = texture2D(op1, v_tc);\n"					//   0,   0
	"\n"
	"    vec2 v_weight_x03 = v_Weight_1to2(vec2(1.0 + v_frac_tc.x, 2.0 - v_frac_tc.x));\n"
	"\n"
	"    vec4 v_sam21 = texture2D(op1, v_tc + v_pixel_size.xw);\n"	//  dt,   0
	"    vec4 v_sam31 = texture2D(op1, v_tc + v_pixel_size2.xw);\n"	// 2dt,   0 ---
	"\n"
	"    vec2 v_weight_y12 = v_Weight_0to1(vec2(v_frac_tc.y, 1.0 - v_frac_tc.y));\n"
	"\n"
	"    vec4 v_sam02 = texture2D(op1, v_tc + v_pixel_size.yz);\n"	// -dt,  dt
	"    vec4 v_sam12 = texture2D(op1, v_tc + v_pixel_size.wz);\n"	//   0,  dt
	"\n"
	"    vec2 v_weight_y03 = v_Weight_1to2(vec2(1.0 + v_frac_tc.y, 2.0 - v_frac_tc.y));\n"
	"\n"
	"    vec4 v_sam22 = texture2D(op1, v_tc + v_pixel_size.xz);\n"	//  dt,  dt
	"    vec4 v_sam32 = texture2D(op1, v_tc + vec2(v_pixel_size2.x, v_pixel_size.z));\n" // 2dt,  dt ---
	"\n"
	"    v_sam00 = v_sam00 * v_weight_x03.x + v_sam10 * v_weight_x12.x +\n"
	"              v_sam20 * v_weight_x12.y + v_sam30 * v_weight_x03.y;\n"
	"    v_sam01 = v_sam01 * v_weight_x03.x + v_sam11 * v_weight_x12.x +\n"
	"              v_sam21 * v_weight_x12.y + v_sam31 * v_weight_x03.y;\n"
	"\n"
	"    vec4 v_sam03 = texture2D(op1, v_tc + vec2(v_pixel_size.y, v_pixel_size2.z));\n" // -dt, ddt
	"    vec4 v_sam13 = texture2D(op1, v_tc + v_pixel_size2.wz);\n"	//   0, 2dt
	"\n"
	"    v_sam02 = v_sam02 * v_weight_x03.x + v_sam12 * v_weight_x12.x +\n"
	"              v_sam22 * v_weight_x12.y + v_sam32 * v_weight_x03.y;\n"
	"\n"
	"    vec4 v_sam23 = texture2D(op1, v_tc + vec2(v_pixel_size.x, v_pixel_size2.z));\n" //  dt, ddt
	"    vec4 v_sam33 = texture2D(op1, v_tc + v_pixel_size2.xz);\n"	// 2dt, 2dt
	"\n"
	"    v_sam03 = v_sam03 * v_weight_x03.x + v_sam13 * v_weight_x12.x +\n"
	"              v_sam23 * v_weight_x12.y + v_sam33 * v_weight_x03.y;\n"
	"    gl_FragColor = v_sam00 * v_weight_y03.x + v_sam01 * v_weight_y12.x +\n"
	"                   v_sam02 * v_weight_y12.y + v_sam03 * v_weight_y03.y;\n"
	"}\n");
// 16-sample bicubic filtering shader (alternating texture / math yields better performance; doesn't necessarily lead to alpha = 1)

TShaderInfo sinc16_shader("sinc16_shader", true,
	"uniform sampler2D op1;\n"
	"varying vec4 v_pixel_size;\n" // needs ps_calc_shader to fill this
	"\n"
	"void main()\n"
	"{\n"
	"    vec2 v_frac_tc = mod(gl_TexCoord[0].xy, v_pixel_size.xz);\n"
	"    vec2 v_tc = gl_TexCoord[0].xy - v_frac_tc;\n"
	"\n"
	"    vec4 v_result = vec4(.0, .0, .0, .0);"
	"    vec2 v_inv_pixel_size = 1.0 / v_pixel_size.xz\n;"
	"    vec2 v_off = -7.0 * v_pixel_size.xz;\n"
	"    float f_off_start_x = v_off.x;\n"
	"    for(int i = 0; i < 16; ++ i) {\n"
	"        for(int j = 0; j < 16; ++ j) {\n"
	"            float f_x = abs(v_off.x) * v_inv_pixel_size.x;\n"
	"            float f_y = abs(v_off.y) * v_inv_pixel_size.y;\n"
	"            if(f_x == .0)\n"
	"                f_x = 1.0;\n"
	"            else {\n"
	"                f_x *= 3.1415926535897932384626433832795028841971691075;\n"
	"                f_x = (sin(f_x) / f_x);\n"
	"            }\n;"
	"            if(f_y == .0)\n"
	"                f_y = 1.0;\n"
	"            else {\n"
	"                f_y *= 3.1415926535897932384626433832795028841971691075;\n"
	"                f_y = (sin(f_y) / f_y);\n"
	"            }\n;"
	"            v_result += texture2D(op1, v_tc + v_off) * f_x * f_y;"
	"            v_off.x += v_pixel_size.x;\n"
	"        }\n"
	"        v_off.x = f_off_start_x;\n"
	"        v_off.y += v_pixel_size.z;\n"
	"    }\n"
	"\n"
	"    gl_FragColor = v_result;\n"
	"}\n");
// 256-sample sinc filtering shader (doesn't necessarily lead to alpha = 1)

TShaderInfo sep_mean_shader("sep_mean_shader", true,
	"uniform sampler2D operand1;\n"
	"uniform vec2 v_offset, v_origin;\n"
	"uniform int n_kernel_size;\n"
	"uniform float f_scale;\n"
	"void main()\n"
	"{\n"
	"    vec4 v_sum = vec4(.0, .0, .0, .0);\n"
	"    vec2 v_texcoord = gl_TexCoord[0].xy + v_origin;\n"
	"    for(int i = 0; i < n_kernel_size; ++ i) {\n"
	"        v_sum += texture2D(operand1, v_texcoord);\n"
	"        v_texcoord += v_offset;\n"
	"    }\n"
	"    gl_FragColor = v_sum * f_scale;\n"
	"}\n");
// separable mean filter (doesn't necessarily lead to alpha = 1)

TShaderInfo sep_median3_shader("sep_median3_shader", true,
    "uniform sampler2D operand1;\n"
    "uniform vec2 v_offset;\n"
    "void main()\n"
    "{\n"
    "    vec4 v_sam0 = texture2D(operand1, gl_TexCoord[0].xy - v_offset);\n"
    "    vec4 v_sam1 = texture2D(operand1, gl_TexCoord[0].xy);\n"
    "    vec4 v_sam2 = texture2D(operand1, gl_TexCoord[0].xy + v_offset);\n"
    "\n"
    "    vec4 v_temp;\n"
    "\n"
    "    v_temp = min(v_sam2, v_sam1); v_sam1 = max(v_sam2, v_sam1); v_sam2 = v_temp; // -(2, 1)\n"
    "    v_temp = min(v_sam2, v_sam0); v_sam0 = max(v_sam2, v_sam0); v_sam2 = v_temp; // -(2, 0)\n"
    "    v_temp = min(v_sam1, v_sam0); v_sam0 = max(v_sam1, v_sam0); v_sam1 = v_temp; // -(1, 0)\n"
    "\n"
    "    gl_FragColor = v_sam1;\n"
    "}\n");
// 3 pixel median filter (doesn't necessarily lead to alpha = 1)

TShaderInfo sep_median5_shader("sep_median5_shader", true,
    "uniform sampler2D operand1;\n"
    "uniform vec2 v_offset;\n"
    "void main()\n"
    "{\n"
    "    vec4 v_sam0 = texture2D(operand1, gl_TexCoord[0].xy - 2.0 * v_offset);\n"
    "    vec4 v_sam1 = texture2D(operand1, gl_TexCoord[0].xy - v_offset);\n"
    "    vec4 v_sam2 = texture2D(operand1, gl_TexCoord[0].xy);\n"
    "    vec4 v_sam3 = texture2D(operand1, gl_TexCoord[0].xy + v_offset);\n"
    "    vec4 v_sam4 = texture2D(operand1, gl_TexCoord[0].xy + 2.0 * v_offset);\n"
    "\n"
    "    vec4 v_temp;\n"
    "\n"
    "    v_temp = min(v_sam0, v_sam1); v_sam1 = max(v_sam0, v_sam1); v_sam0 = v_temp; // +(0, 1)\n"
    "    v_temp = min(v_sam4, v_sam3); v_sam3 = max(v_sam4, v_sam3); v_sam4 = v_temp; // -(4, 3)\n"
    "    v_temp = min(v_sam4, v_sam2); v_sam2 = max(v_sam4, v_sam2); v_sam4 = v_temp; // -(4, 2)\n"
    "    v_temp = min(v_sam3, v_sam2); v_sam2 = max(v_sam3, v_sam2); v_sam3 = v_temp; // -(3, 2)\n"
    "    v_temp = min(v_sam4, v_sam0); v_sam0 = max(v_sam4, v_sam0); v_sam4 = v_temp; // -(4, 0)\n"
    "    v_temp = min(v_sam2, v_sam0); v_sam0 = max(v_sam2, v_sam0); v_sam2 = v_temp; // -(2, 0)\n"
    "    v_temp = min(v_sam3, v_sam1); v_sam1 = max(v_sam3, v_sam1); v_sam3 = v_temp; // -(3, 1)\n"
    //"    v_temp = min(v_sam1, v_sam0); v_sam0 = max(v_sam1, v_sam0); v_sam1 = v_temp; // -(1, 0)\n"
    "    v_temp = min(v_sam3, v_sam2); v_sam2 = max(v_sam3, v_sam2); v_sam3 = v_temp; // -(3, 2)\n"
    "\n"
    "    gl_FragColor = v_sam2;\n"
    "}\n");
// 5 pixel median filter (doesn't necessarily lead to alpha = 1)

TShaderInfo sep_median7_shader("sep_median7_shader", true,
    "uniform sampler2D operand1;\n"
    "uniform vec2 v_offset;\n"
    "void main()\n"
    "{\n"
    "    vec4 v_sam0 = texture2D(operand1, gl_TexCoord[0].xy - 3.0 * v_offset);\n"
    "    vec4 v_sam1 = texture2D(operand1, gl_TexCoord[0].xy - 2.0 * v_offset);\n"
    "    vec4 v_sam2 = texture2D(operand1, gl_TexCoord[0].xy - v_offset);\n"
    "    vec4 v_sam3 = texture2D(operand1, gl_TexCoord[0].xy);\n"
    "    vec4 v_sam4 = texture2D(operand1, gl_TexCoord[0].xy + v_offset);\n"
    "    vec4 v_sam5 = texture2D(operand1, gl_TexCoord[0].xy + 2.0 * v_offset);\n"
    "    vec4 v_sam6 = texture2D(operand1, gl_TexCoord[0].xy + 3.0 * v_offset);\n"
    "\n"
    "    vec4 v_temp;\n"
    "\n"
    "    v_temp = min(v_sam1, v_sam2); v_sam2 = max(v_sam1, v_sam2); v_sam1 = v_temp; // +(1, 2)\n"
    "    v_temp = min(v_sam0, v_sam2); v_sam2 = max(v_sam0, v_sam2); v_sam0 = v_temp; // +(0, 2)\n"
    "    v_temp = min(v_sam0, v_sam1); v_sam1 = max(v_sam0, v_sam1); v_sam0 = v_temp; // +(0, 1)\n"
    "    v_temp = min(v_sam3, v_sam4); v_sam4 = max(v_sam3, v_sam4); v_sam3 = v_temp; // +(3, 4)\n"
    "    v_temp = min(v_sam6, v_sam5); v_sam5 = max(v_sam6, v_sam5); v_sam6 = v_temp; // -(6, 5)\n"
    "    v_temp = min(v_sam5, v_sam3); v_sam3 = max(v_sam5, v_sam3); v_sam5 = v_temp; // -(5, 3)\n"
    "    v_temp = min(v_sam6, v_sam4); v_sam4 = max(v_sam6, v_sam4); v_sam6 = v_temp; // -(6, 4)\n"
    "    v_temp = min(v_sam4, v_sam3); v_sam3 = max(v_sam4, v_sam3); v_sam4 = v_temp; // -(4, 3)\n"
    "    v_temp = min(v_sam6, v_sam5); v_sam5 = max(v_sam6, v_sam5); v_sam6 = v_temp; // -(6, 5)\n"
    "    v_temp = min(v_sam4, v_sam0); v_sam0 = max(v_sam4, v_sam0); v_sam4 = v_temp; // -(4, 0)\n"
    "    v_temp = min(v_sam5, v_sam1); v_sam1 = max(v_sam5, v_sam1); v_sam5 = v_temp; // -(5, 1)\n"
    "    v_temp = min(v_sam6, v_sam2); v_sam2 = max(v_sam6, v_sam2); v_sam6 = v_temp; // -(6, 2)\n"
    "    v_temp = min(v_sam2, v_sam0); v_sam0 = max(v_sam2, v_sam0); v_sam2 = v_temp; // -(2, 0)\n"
    "    v_temp = min(v_sam3, v_sam1); v_sam1 = max(v_sam3, v_sam1); v_sam3 = v_temp; // -(3, 1)\n"
    //"    v_temp = min(v_sam1, v_sam0); v_sam0 = max(v_sam1, v_sam0); v_sam1 = v_temp; // -(1, 0)\n"
    "    v_temp = min(v_sam3, v_sam2); v_sam2 = max(v_sam3, v_sam2); v_sam3 = v_temp; // -(3, 2)\n"
    //"    v_temp = min(v_sam6, v_sam4); v_sam4 = max(v_sam6, v_sam4); v_sam6 = v_temp; // -(6, 4)\n"
    //"    v_temp = min(v_sam5, v_sam4); v_sam4 = max(v_sam5, v_sam4); v_sam5 = v_temp; // -(5, 4)\n"
    "\n"
    "    gl_FragColor = v_sam3;\n"
    "}\n");
// 7 pixel median filter (doesn't necessarily lead to alpha = 1)

TShaderInfo sep_median15_shader("sep_median15_shader", true,
    "uniform sampler2D operand1;\n"
    "uniform vec2 v_offset;\n"
    "void main()\n"
    "{\n"
    "    vec4 v_sam0 = texture2D(operand1, gl_TexCoord[0].xy - 7.0 * v_offset);\n"
    "    vec4 v_sam1 = texture2D(operand1, gl_TexCoord[0].xy - 6.0 * v_offset);\n"
    "    vec4 v_sam2 = texture2D(operand1, gl_TexCoord[0].xy - 5.0 * v_offset);\n"
    "    vec4 v_sam3 = texture2D(operand1, gl_TexCoord[0].xy - 4.0 * v_offset);\n"
    "    vec4 v_sam4 = texture2D(operand1, gl_TexCoord[0].xy - 3.0 * v_offset);\n"
    "    vec4 v_sam5 = texture2D(operand1, gl_TexCoord[0].xy - 2.0 * v_offset);\n"
    "    vec4 v_sam6 = texture2D(operand1, gl_TexCoord[0].xy - v_offset);\n"
    "    vec4 v_sam7 = texture2D(operand1, gl_TexCoord[0].xy);\n"
    "    vec4 v_sam8 = texture2D(operand1, gl_TexCoord[0].xy + v_offset);\n"
    "    vec4 v_sam9 = texture2D(operand1, gl_TexCoord[0].xy + 2.0 * v_offset);\n"
    "    vec4 v_sam10 = texture2D(operand1, gl_TexCoord[0].xy + 3.0 * v_offset);\n"
    "    vec4 v_sam11 = texture2D(operand1, gl_TexCoord[0].xy + 4.0 * v_offset);\n"
    "    vec4 v_sam12 = texture2D(operand1, gl_TexCoord[0].xy + 5.0 * v_offset);\n"
    "    vec4 v_sam13 = texture2D(operand1, gl_TexCoord[0].xy + 6.0 * v_offset);\n"
    "    vec4 v_sam14 = texture2D(operand1, gl_TexCoord[0].xy + 7.0 * v_offset);\n"
    "\n"
    "    vec4 v_temp;\n"
    "\n"
    "    v_temp = min(v_sam2, v_sam1); v_sam1 = max(v_sam2, v_sam1); v_sam2 = v_temp; // -(2, 1)\n"
    "    v_temp = min(v_sam2, v_sam0); v_sam0 = max(v_sam2, v_sam0); v_sam2 = v_temp; // -(2, 0)\n"
    "    v_temp = min(v_sam1, v_sam0); v_sam0 = max(v_sam1, v_sam0); v_sam1 = v_temp; // -(1, 0)\n"
    "    v_temp = min(v_sam4, v_sam3); v_sam3 = max(v_sam4, v_sam3); v_sam4 = v_temp; // -(4, 3)\n"
    "    v_temp = min(v_sam5, v_sam6); v_sam6 = max(v_sam5, v_sam6); v_sam5 = v_temp; // +(5, 6)\n"
    "    v_temp = min(v_sam3, v_sam5); v_sam5 = max(v_sam3, v_sam5); v_sam3 = v_temp; // +(3, 5)\n"
    "    v_temp = min(v_sam4, v_sam6); v_sam6 = max(v_sam4, v_sam6); v_sam4 = v_temp; // +(4, 6)\n"
    "    v_temp = min(v_sam3, v_sam4); v_sam4 = max(v_sam3, v_sam4); v_sam3 = v_temp; // +(3, 4)\n"
    "    v_temp = min(v_sam5, v_sam6); v_sam6 = max(v_sam5, v_sam6); v_sam5 = v_temp; // +(5, 6)\n"
    "    v_temp = min(v_sam0, v_sam4); v_sam4 = max(v_sam0, v_sam4); v_sam0 = v_temp; // +(0, 4)\n"
    "    v_temp = min(v_sam1, v_sam5); v_sam5 = max(v_sam1, v_sam5); v_sam1 = v_temp; // +(1, 5)\n"
    "    v_temp = min(v_sam2, v_sam6); v_sam6 = max(v_sam2, v_sam6); v_sam2 = v_temp; // +(2, 6)\n"
    "    v_temp = min(v_sam0, v_sam2); v_sam2 = max(v_sam0, v_sam2); v_sam0 = v_temp; // +(0, 2)\n"
    "    v_temp = min(v_sam1, v_sam3); v_sam3 = max(v_sam1, v_sam3); v_sam1 = v_temp; // +(1, 3)\n"
    "    v_temp = min(v_sam0, v_sam1); v_sam1 = max(v_sam0, v_sam1); v_sam0 = v_temp; // +(0, 1)\n"
    "    v_temp = min(v_sam2, v_sam3); v_sam3 = max(v_sam2, v_sam3); v_sam2 = v_temp; // +(2, 3)\n"
    "    v_temp = min(v_sam4, v_sam6); v_sam6 = max(v_sam4, v_sam6); v_sam4 = v_temp; // +(4, 6)\n"
    "    v_temp = min(v_sam4, v_sam5); v_sam5 = max(v_sam4, v_sam5); v_sam4 = v_temp; // +(4, 5)\n"
    "    v_temp = min(v_sam8, v_sam7); v_sam7 = max(v_sam8, v_sam7); v_sam8 = v_temp; // -(8, 7)\n"
    "    v_temp = min(v_sam9, v_sam10); v_sam10 = max(v_sam9, v_sam10); v_sam9 = v_temp; // +(9, 10)\n"
    "    v_temp = min(v_sam7, v_sam9); v_sam9 = max(v_sam7, v_sam9); v_sam7 = v_temp; // +(7, 9)\n"
    "    v_temp = min(v_sam8, v_sam10); v_sam10 = max(v_sam8, v_sam10); v_sam8 = v_temp; // +(8, 10)\n"
    "    v_temp = min(v_sam7, v_sam8); v_sam8 = max(v_sam7, v_sam8); v_sam7 = v_temp; // +(7, 8)\n"
    "    v_temp = min(v_sam9, v_sam10); v_sam10 = max(v_sam9, v_sam10); v_sam9 = v_temp; // +(9, 10)\n"
    "    v_temp = min(v_sam11, v_sam12); v_sam12 = max(v_sam11, v_sam12); v_sam11 = v_temp; // +(11, 12)\n"
    "    v_temp = min(v_sam14, v_sam13); v_sam13 = max(v_sam14, v_sam13); v_sam14 = v_temp; // -(14, 13)\n"
    "    v_temp = min(v_sam13, v_sam11); v_sam11 = max(v_sam13, v_sam11); v_sam13 = v_temp; // -(13, 11)\n"
    "    v_temp = min(v_sam14, v_sam12); v_sam12 = max(v_sam14, v_sam12); v_sam14 = v_temp; // -(14, 12)\n"
    "    v_temp = min(v_sam12, v_sam11); v_sam11 = max(v_sam12, v_sam11); v_sam12 = v_temp; // -(12, 11)\n"
    "    v_temp = min(v_sam14, v_sam13); v_sam13 = max(v_sam14, v_sam13); v_sam14 = v_temp; // -(14, 13)\n"
    "    v_temp = min(v_sam11, v_sam7); v_sam7 = max(v_sam11, v_sam7); v_sam11 = v_temp; // -(11, 7)\n"
    "    v_temp = min(v_sam12, v_sam8); v_sam8 = max(v_sam12, v_sam8); v_sam12 = v_temp; // -(12, 8)\n"
    "    v_temp = min(v_sam13, v_sam9); v_sam9 = max(v_sam13, v_sam9); v_sam13 = v_temp; // -(13, 9)\n"
    "    v_temp = min(v_sam14, v_sam10); v_sam10 = max(v_sam14, v_sam10); v_sam14 = v_temp; // -(14, 10)\n"
    "    v_temp = min(v_sam9, v_sam7); v_sam7 = max(v_sam9, v_sam7); v_sam9 = v_temp; // -(9, 7)\n"
    "    v_temp = min(v_sam10, v_sam8); v_sam8 = max(v_sam10, v_sam8); v_sam10 = v_temp; // -(10, 8)\n"
    "    v_temp = min(v_sam8, v_sam7); v_sam7 = max(v_sam8, v_sam7); v_sam8 = v_temp; // -(8, 7)\n"
    "    v_temp = min(v_sam10, v_sam9); v_sam9 = max(v_sam10, v_sam9); v_sam10 = v_temp; // -(10, 9)\n"
    "    v_temp = min(v_sam13, v_sam11); v_sam11 = max(v_sam13, v_sam11); v_sam13 = v_temp; // -(13, 11)\n"
    "    v_temp = min(v_sam14, v_sam12); v_sam12 = max(v_sam14, v_sam12); v_sam14 = v_temp; // -(14, 12)\n"
    "    v_temp = min(v_sam12, v_sam11); v_sam11 = max(v_sam12, v_sam11); v_sam12 = v_temp; // -(12, 11)\n"
    "    v_temp = min(v_sam14, v_sam13); v_sam13 = max(v_sam14, v_sam13); v_sam14 = v_temp; // -(14, 13)\n"
    "    v_temp = min(v_sam8, v_sam0); v_sam0 = max(v_sam8, v_sam0); v_sam8 = v_temp; // -(8, 0)\n"
    "    v_temp = min(v_sam9, v_sam1); v_sam1 = max(v_sam9, v_sam1); v_sam9 = v_temp; // -(9, 1)\n"
    "    v_temp = min(v_sam10, v_sam2); v_sam2 = max(v_sam10, v_sam2); v_sam10 = v_temp; // -(10, 2)\n"
    "    v_temp = min(v_sam11, v_sam3); v_sam3 = max(v_sam11, v_sam3); v_sam11 = v_temp; // -(11, 3)\n"
    "    v_temp = min(v_sam12, v_sam4); v_sam4 = max(v_sam12, v_sam4); v_sam12 = v_temp; // -(12, 4)\n"
    "    v_temp = min(v_sam13, v_sam5); v_sam5 = max(v_sam13, v_sam5); v_sam13 = v_temp; // -(13, 5)\n"
    "    v_temp = min(v_sam14, v_sam6); v_sam6 = max(v_sam14, v_sam6); v_sam14 = v_temp; // -(14, 6)\n"
    "    v_temp = min(v_sam4, v_sam0); v_sam0 = max(v_sam4, v_sam0); v_sam4 = v_temp; // -(4, 0)\n"
    "    v_temp = min(v_sam5, v_sam1); v_sam1 = max(v_sam5, v_sam1); v_sam5 = v_temp; // -(5, 1)\n"
    "    v_temp = min(v_sam6, v_sam2); v_sam2 = max(v_sam6, v_sam2); v_sam6 = v_temp; // -(6, 2)\n"
    "    v_temp = min(v_sam7, v_sam3); v_sam3 = max(v_sam7, v_sam3); v_sam7 = v_temp; // -(7, 3)\n"
    //"    v_temp = min(v_sam2, v_sam0); v_sam0 = max(v_sam2, v_sam0); v_sam2 = v_temp; // -(2, 0)\n"
    //"    v_temp = min(v_sam3, v_sam1); v_sam1 = max(v_sam3, v_sam1); v_sam3 = v_temp; // -(3, 1)\n"
    //"    v_temp = min(v_sam1, v_sam0); v_sam0 = max(v_sam1, v_sam0); v_sam1 = v_temp; // -(1, 0)\n"
    //"    v_temp = min(v_sam3, v_sam2); v_sam2 = max(v_sam3, v_sam2); v_sam3 = v_temp; // -(3, 2)\n"
    "    v_temp = min(v_sam6, v_sam4); v_sam4 = max(v_sam6, v_sam4); v_sam6 = v_temp; // -(6, 4)\n"
    "    v_temp = min(v_sam7, v_sam5); v_sam5 = max(v_sam7, v_sam5); v_sam7 = v_temp; // -(7, 5)\n"
    //"    v_temp = min(v_sam5, v_sam4); v_sam4 = max(v_sam5, v_sam4); v_sam5 = v_temp; // -(5, 4)\n"
    "    v_temp = min(v_sam7, v_sam6); v_sam6 = max(v_sam7, v_sam6); v_sam7 = v_temp; // -(7, 6)\n"
    /*"    v_temp = min(v_sam12, v_sam8); v_sam8 = max(v_sam12, v_sam8); v_sam12 = v_temp; // -(12, 8)\n"
    "    v_temp = min(v_sam13, v_sam9); v_sam9 = max(v_sam13, v_sam9); v_sam13 = v_temp; // -(13, 9)\n"
    "    v_temp = min(v_sam14, v_sam10); v_sam10 = max(v_sam14, v_sam10); v_sam14 = v_temp; // -(14, 10)\n"
    "    v_temp = min(v_sam10, v_sam8); v_sam8 = max(v_sam10, v_sam8); v_sam10 = v_temp; // -(10, 8)\n"
    "    v_temp = min(v_sam11, v_sam9); v_sam9 = max(v_sam11, v_sam9); v_sam11 = v_temp; // -(11, 9)\n"
    "    v_temp = min(v_sam9, v_sam8); v_sam8 = max(v_sam9, v_sam8); v_sam9 = v_temp; // -(9, 8)\n"
    "    v_temp = min(v_sam11, v_sam10); v_sam10 = max(v_sam11, v_sam10); v_sam11 = v_temp; // -(11, 10)\n"
    "    v_temp = min(v_sam14, v_sam12); v_sam12 = max(v_sam14, v_sam12); v_sam14 = v_temp; // -(14, 12)\n"
    "    v_temp = min(v_sam13, v_sam12); v_sam12 = max(v_sam13, v_sam12); v_sam13 = v_temp; // -(13, 12)\n"*/
    "\n"
    "    gl_FragColor = v_sam7;\n"
    "}\n");
// 15 pixel median filter (doesn't necessarily lead to alpha = 1)

TShaderInfo sep_local_min_shader("sep_local_min_shader", true,
	"uniform sampler2D operand1;\n"
	"uniform vec2 v_offset, v_origin;\n"
	"uniform int n_kernel_size;\n"
	"void main()\n"
	"{\n"
	"    vec2 v_texcoord = gl_TexCoord[0].xy + v_origin;\n"
	"    vec4 v_min = texture2D(operand1, v_texcoord);\n"
	"    for(int i = 1; i < n_kernel_size; ++ i) {\n"
	"        v_texcoord += v_offset;\n"
	"        v_min = min(v_min, texture2D(operand1, v_texcoord));\n"
	"    }\n"
	"    gl_FragColor = v_min;\n"
	"}\n");
// separable min finder (doesn't necessarily lead to alpha = 1)

TShaderInfo sep_local_max_shader("sep_local_max_shader", true,
	"uniform sampler2D operand1;\n"
	"uniform vec2 v_offset, v_origin;\n"
	"uniform int n_kernel_size;\n"
	"void main()\n"
	"{\n"
	"    vec2 v_texcoord = gl_TexCoord[0].xy + v_origin;\n"
	"    vec4 v_max = texture2D(operand1, v_texcoord);\n"
	"    for(int i = 1; i < n_kernel_size; ++ i) {\n"
	"        v_texcoord += v_offset;\n"
	"        v_max = max(v_max, texture2D(operand1, v_texcoord));\n"
	"    }\n"
	"    gl_FragColor = v_max;\n"
	"}\n");
// separable max finder (doesn't necessarily lead to alpha = 1)

TShaderInfo erode_square_shader("erode_square_shader", true,
	"uniform sampler2D operand1;\n"
	"uniform vec2 v_offset, v_origin;\n"
	"uniform int n_kernel_w, n_kernel_h;\n"
	"void main()\n"
	"{\n"
	"    vec2 v_texcoord = gl_TexCoord[0].xy + v_origin;\n"
	"    vec4 v_out = vec4(1, 1, 1, 1);\n"
	"    for(int i = 0; i < n_kernel_h; ++ i) {\n"
	"        vec2 v_inner_texcoord = v_texcoord;\n" // inner loop needs it's own texcoord
	"        for(int j = 0; j < n_kernel_w; ++ j) {\n"
	"            v_out *= step(.5, texture2D(operand1, v_inner_texcoord));\n" // sets zeroes where texture value is below .5
	"            v_inner_texcoord.x += v_offset.x;\n"
	"        }\n"
	"        v_texcoord.y += v_offset.y;\n"
	"        if(all(equal(v_out, vec4(0, 0, 0, 0))))\n"
	"            break;\n" // early cutoff, saves sampling
	"    }\n"
	"    gl_FragColor = v_out;\n"
	"}\n");
// erode square-kernel shader (doesn't necessarily lead to alpha = 1)

TShaderInfo dilate_square_shader("dilate_square_shader", true,
	"uniform sampler2D operand1;\n"
	"uniform vec2 v_offset, v_origin;\n"
	"uniform int n_kernel_w, n_kernel_h;\n"
	"void main()\n"
	"{\n"
	"    vec2 v_texcoord = gl_TexCoord[0].xy + v_origin;\n"
	"    vec4 v_out = vec4(0, 0, 0, 0);\n"
	"    for(int i = 0; i < n_kernel_h; ++ i) {\n"
	"        vec2 v_inner_texcoord = v_texcoord;\n" // inner loop needs it's own texcoord
	"        for(int j = 0; j < n_kernel_w; ++ j) {\n"
	"            v_out = max(v_out, step(.5, texture2D(operand1, v_inner_texcoord)));\n" // sets ones where texture value is above .5
	"            v_inner_texcoord.x += v_offset.x;\n"
	"        }\n"
	"        v_texcoord.y += v_offset.y;\n"
	"        if(all(equal(v_out, vec4(1, 1, 1, 1))))\n"
	"            break;\n" // early cutoff, saves sampling
	"    }\n"
	"    gl_FragColor = v_out;\n"
	"}\n");
// dilate square-kernel shader (doesn't necessarily lead to alpha = 1)

TShaderInfo erode_diamond_shader("erode_diamond_shader", true,
	"uniform sampler2D operand1;\n"
	"uniform vec2 v_offset, v_origin;\n"
	"uniform int n_kernel_w, n_kernel_h;\n"
	"void main()\n"
	"{\n"
	"    vec2 v_texcoord = gl_TexCoord[0].xy + v_origin;\n"
	"    vec4 v_out = vec4(1, 1, 1, 1);\n"
	"    for(int i = 0, n = n_kernel_h / 2, m = n_kernel_h / 4; i < n_kernel_h; ++ i) {\n"
	"        int n_space = (i < n)? (n - m) - i : i - (n + m);\n"
	"        n_space = (n_space < 0)? 0 : n_space;\n"
	"        vec2 v_inner_texcoord = v_texcoord;\n" // inner loop needs it's own texcoord
	"        v_inner_texcoord.x += (float(n_space) * v_offset.x);\n"
	"        for(int j = n_space; j < n_kernel_w - n_space; ++ j) {\n"
	"            v_out *= step(.5, texture2D(operand1, v_inner_texcoord));\n" // sets zeros where texture value is below .5
	"            v_inner_texcoord.x += v_offset.x;\n"
	"        }\n"
	"        v_texcoord.y += v_offset.y;\n"
	"        if(all(equal(v_out, vec4(0, 0, 0, 0))))\n"
	"            break;\n" // early cutoff, saves sampling
	"    }\n"
	"    gl_FragColor = v_out;\n"
	"}\n");
// erode diamond-kernel shader (doesn't necessarily lead to alpha = 1)

TShaderInfo dilate_diamond_shader("dilate_diamond_shader", true,
	"uniform sampler2D operand1;\n"
	"uniform vec2 v_offset, v_origin;\n"
	"uniform int n_kernel_w, n_kernel_h;\n"
	"void main()\n"
	"{\n"
	"    vec2 v_texcoord = gl_TexCoord[0].xy + v_origin;\n"
	"    vec4 v_out = vec4(0, 0, 0, 0);\n"
	"    for(int i = 0, n = n_kernel_h / 2, m = n_kernel_h / 4; i < n_kernel_h; ++ i) {\n"
	"        int n_space = (i < n)? (n - m) - i : i - (n + m);\n"
	"        n_space = (n_space < 0)? 0 : n_space;\n"
	"        vec2 v_inner_texcoord = v_texcoord;\n" // inner loop needs it's own texcoord
	"        v_inner_texcoord.x += (float(n_space) * v_offset.x);\n"
	"        for(int j = n_space; j < (n_kernel_w - n_space); ++ j) {\n"
	"            v_out = max(v_out, step(.5, texture2D(operand1, v_inner_texcoord)));\n" // sets ones where texture value is above .5
	"            v_inner_texcoord.x += v_offset.x;\n"
	"        }\n"
	"        v_texcoord.y += v_offset.y;\n"
	"        if(all(equal(v_out, vec4(1, 1, 1, 1))))\n"
	"            break;\n" // early cutoff, saves sampling
	"    }\n"
	"    gl_FragColor = v_out;\n"
	"}\n");
// dilate diamond-kernel shader (doesn't necessarily lead to alpha = 1)

TShaderInfo k2d_cs_shader("k2d_cs_shader", false,
	"uniform int n_kernel_w, n_kernel_h;\n"
	"varying vec2 v_kernel_step;\n"
	"void main()\n"
	"{\n"
	"    gl_Position = ftransform();\n"
	"    gl_TexCoord[0] = gl_MultiTexCoord0;\n"
	"    v_kernel_step = vec2(1.0 / float(n_kernel_w), 1.0 / float(n_kernel_h));\n"
	"}\n");

TShaderInfo erode_image_shader("erode_image_shader", true,
	"uniform sampler2D operand1, operand2;\n"
	"uniform vec2 v_offset, v_origin;\n"
	"uniform int n_kernel_w, n_kernel_h;\n"
	"varying vec2 v_kernel_step;\n" // needs k2d_cs_shader to fill this up
	"void main()\n"
	"{\n"
	"    vec2 v_texcoord = gl_TexCoord[0].xy + v_origin;\n"
	"    vec4 v_out = vec4(1, 1, 1, 1);\n"
	"    float t = .0;\n"
	"    for(int j = 0; j < n_kernel_h; ++ j, t += v_kernel_step.y) {\n"
	"        vec2 v_inner_texcoord = v_texcoord;\n" // inner loop needs it's own texcoord
	"        float s = .0;\n"
	"        for(int i = 0; i < n_kernel_w; ++ i, s += v_kernel_step.x) {\n"
	"            vec4 v_kernel = step(-.5, -(texture2D(operand2, vec2(s, t))));\n" // negative binary kernel value
	"            v_out *= step(.5, max(v_kernel, texture2D(operand1, v_inner_texcoord)));\n" // sets zero where texture value is under .5 and kernel is not zero
	"            v_inner_texcoord.x += v_offset.x;\n"
	"        }\n"
	"        v_texcoord.y += v_offset.y;\n"
	"        if(all(equal(v_out, vec4(0, 0, 0, 0))))\n"
	"            break;\n" // early cutoff, saves sampling
	"    }\n"
	"    gl_FragColor = v_out;\n"
	"}\n", "operand1|operand2");
// erode image-kernel shader (doesn't necessarily lead to alpha = 1)

TShaderInfo dilate_image_shader("dilate_image_shader", true,
	"uniform sampler2D operand1, operand2;\n"
	"uniform vec2 v_offset, v_origin;\n"
	"uniform int n_kernel_w, n_kernel_h;\n"
	"varying vec2 v_kernel_step;\n" // needs k2d_cs_shader to fill this up
	"void main()\n"
	"{\n"
	"    vec2 v_texcoord = gl_TexCoord[0].xy + v_origin;\n"
	"    vec4 v_out = vec4(0, 0, 0, 0);\n"
	"    float t = .0;\n"
	"    for(int j = 0; j < n_kernel_h; ++ j, t += v_kernel_step.y) {\n"
	"        vec2 v_inner_texcoord = v_texcoord;\n" // inner loop needs it's own texcoord
	"        float s = .0;\n"
	"        for(int i = 0; i < n_kernel_w; ++ i, s += v_kernel_step.x) {\n"
	"            vec4 v_kernel = step(.5, texture2D(operand2, vec2(s, t)));\n" // binary kernel value
	"            v_out = max(v_out, v_kernel * step(.5, texture2D(operand1, v_inner_texcoord)));\n" // sets one where kernel is one and texture value is above .5
	"            v_inner_texcoord.x += v_offset.x;\n"
	"        }\n"
	"        v_texcoord.y += v_offset.y;\n"
	"        if(all(equal(v_out, vec4(1, 1, 1, 1))))\n"
	"            break;\n" // early cutoff, saves sampling
	"    }\n"
	"    gl_FragColor = v_out;\n"
	"}\n", "operand1|operand2");
// dilate image-kernel shader (doesn't necessarily lead to alpha = 1)

TShaderInfo morph_hitmiss_shader("morph_hitmiss_shader", true,
	"uniform sampler2D operand1, operand2;\n"
	"uniform vec2 v_offset, v_origin;\n"
	"uniform int n_kernel_w, n_kernel_h;\n"
	"varying vec2 v_kernel_step;\n" // needs k2d_cs_shader to fill this up
	"void main()\n"
	"{\n"
	"    vec2 v_texcoord = gl_TexCoord[0].xy + v_origin;\n"
	"    vec4 v_out = vec4(1, 1, 1, 1);\n"
	"    float t = .0;\n"
	"    for(int j = 0; j < n_kernel_h; ++ j, t += v_kernel_step.y) {\n"
	"        vec2 v_inner_texcoord = v_texcoord;\n" // inner loop needs it's own texcoord
	"        float s = .0;\n"
	"        for(int i = 0; i < n_kernel_w; ++ i, s += v_kernel_step.x) {\n"
	"            vec4 v_kernel = texture2D(operand2, vec2(s, t));\n" // kernel value
	"            vec4 v_sample = texture2D(operand1, v_inner_texcoord);\n" // sample value
	"            v_out *= step(-.7, -abs(v_kernel - v_sample));\n" // sets zero where difference between kernel value and sample value is over .75 (i.e. value .5 = don't care)
	"            v_inner_texcoord.x += v_offset.x;\n"
	"        }\n"
	"        v_texcoord.y += v_offset.y;\n"
	"        if(all(equal(v_out, vec4(0, 0, 0, 0))))\n"
	"            break;\n" // early cutoff, saves sampling
	"    }\n"
	"    gl_FragColor = v_out;\n"
	"}\n", "operand1|operand2");
// morphologic hit-miss shader (doesn't necessarily lead to alpha = 1)

TShaderInfo k1d_cs_shader("k1d_cs_shader", false,
	"uniform int n_kernel_size;\n"
	"varying float f_kernel_step;\n"
	"void main()\n"
	"{\n"
	"    gl_Position = ftransform();\n"
	"    gl_TexCoord[0] = gl_MultiTexCoord0;\n"
	"    f_kernel_step = 1.0 / float(n_kernel_size);\n"
	"}\n");

TShaderInfo convolution_separable_shader("convolution_separable_shader", true,
	"uniform sampler2D operand1, operand2;\n"
	"uniform vec2 v_offset, v_origin;\n"
	"uniform int n_kernel_size;\n"
	"varying float f_kernel_step;\n" // needs k1d_cs_shader to fill this up
	"void main()\n"
	"{\n"
	"    vec2 v_texcoord = gl_TexCoord[0].xy + v_origin;\n"
	"    vec4 v_out = vec4(0, 0, 0, 0);\n"
	"    float t = .0;\n"
	"    for(int i = 0; i < n_kernel_size; ++ i, t += f_kernel_step) {\n"
	"        vec4 v_kernel = texture2D(operand2, vec2(t, t));\n" // kernel value (sampling at [t, t] allows for any kernel orientation)
	"        vec4 v_sample = texture2D(operand1, v_texcoord);\n" // sample value
	"        v_out += v_kernel * v_sample;\n"
	"        v_texcoord += v_offset;\n"
	"    }\n"
	"    gl_FragColor = v_out;\n"
	"}\n", "operand1|operand2");
// separable convolution shader (doesn't necessarily lead to alpha = 1)

TShaderInfo convolution_cmplxi_rek_separable_shader("convolution_cmplxi_rek_separable_shader", true,
	"uniform sampler2D operand1, operand2;\n"
	"uniform vec2 v_offset, v_origin;\n"
	"uniform int n_kernel_size;\n"
	"varying float f_kernel_step;\n" // needs k1d_cs_shader to fill this up
	"void main()\n"
	"{\n"
	"    vec2 v_texcoord = gl_TexCoord[0].xy + v_origin;\n"
	"    vec2 v_out = vec2(0, 0);\n"
	"    float t = .0;\n"
	"    for(int i = 0; i < n_kernel_size; ++ i, t += f_kernel_step) {\n"
	"        float f_kernel = texture2D(operand2, vec2(t, t)).x;\n" // real kernel value (sampling at [t, t] allows for any kernel orientation)
	"        vec2 v_sample = texture2D(operand1, v_texcoord).xw;\n" // complex sample value
	"        v_out += f_kernel * v_sample;\n"
	"        v_texcoord += v_offset;\n"
	"    }\n"
	"    gl_FragColor = v_out.xxxy;\n"
	"}\n", "operand1|operand2");
// separable convolution complex image, real kernel shader (doesn't necessarily lead to alpha = 1)

TShaderInfo convolution_rei_cmplxk_separable_shader("convolution_rei_cmplxk_separable_shader", true,
	"uniform sampler2D operand1, operand2;\n"
	"uniform vec2 v_offset, v_origin;\n"
	"uniform int n_kernel_size;\n"
	"varying float f_kernel_step;\n" // needs k1d_cs_shader to fill this up
	"void main()\n"
	"{\n"
	"    vec2 v_texcoord = gl_TexCoord[0].xy + v_origin;\n"
	"    vec2 v_out = vec2(0, 0);\n"
	"    float t = .0;\n"
	"    for(int i = 0; i < n_kernel_size; ++ i, t += f_kernel_step) {\n"
	"        vec2 v_kernel = texture2D(operand2, vec2(t, t)).xw;\n" // complex kernel value (sampling at [t, t] allows for any kernel orientation)
	"        float f_sample = texture2D(operand1, v_texcoord).x;\n" // real sample value
	"        v_out += v_kernel * f_sample;\n"
	"        v_texcoord += v_offset;\n"
	"    }\n"
	"    gl_FragColor = v_out.xxxy;\n"
	"}\n", "operand1|operand2");
// separable convolution real image, complex kernel shader (doesn't necessarily lead to alpha = 1)

TShaderInfo convolution_cmplx2_separable_shader("convolution_cmplx2_separable_shader", true,
	"uniform sampler2D operand1, operand2;\n"
	"uniform vec2 v_offset, v_origin;\n"
	"uniform int n_kernel_size;\n"
	"varying float f_kernel_step;\n" // needs k1d_cs_shader to fill this up
	"void main()\n"
	"{\n"
	"    vec2 v_texcoord = gl_TexCoord[0].xy + v_origin;\n"
	"    vec2 v_out = vec2(0, 0);\n"
	"    float t = .0;\n"
	"    for(int i = 0; i < n_kernel_size; ++ i, t += f_kernel_step) {\n"
	"        vec2 v_kernel = texture2D(operand2, vec2(t, t)).xw;\n" // complex kernel value (sampling at [t, t] allows for any kernel orientation)
	"        vec3 v_sample; v_sample.xy = texture2D(operand1, v_texcoord).xw;\n" // complex sample value
	"        v_sample.z = -v_sample.y;\n"
	"        v_out += vec2(dot(v_kernel, v_sample.xz), dot(v_kernel, v_sample.yx));\n" // cmplx1 * cmplx2 = re1 * re2 - im1 * im2 + j(im1 * re2 + im2 * re1)
	"        v_texcoord += v_offset;\n"
	"    }\n"
	"    gl_FragColor = v_out.xxxy;\n"
	"}\n", "operand1|operand2");
// separable convolution complex image, complex kernel shader (doesn't necessarily lead to alpha = 1)

TShaderInfo convolution_2D_shader("convolution_2D_shader", true,
	"uniform sampler2D operand1, operand2;\n"
	"uniform vec2 v_offset, v_origin;\n"
	"uniform int n_kernel_w, n_kernel_h;\n"
	"varying vec2 v_kernel_step;\n" // needs k2d_cs_shader to fill this up
	"void main()\n"
	"{\n"
	"    vec2 v_texcoord = gl_TexCoord[0].xy + v_origin;\n"
	"    vec4 v_out = vec4(0, 0, 0, 0);\n"
	"    float t = .0;\n"
	"    for(int j = 0; j < n_kernel_h; ++ j, t += v_kernel_step.y) {\n"
	"        vec2 v_inner_texcoord = v_texcoord;\n" // inner loop needs it's own texcoord
	"        float s = .0;\n"
	"        for(int i = 0; i < n_kernel_w; ++ i, s += v_kernel_step.x) {\n"
	"            vec4 v_kernel = texture2D(operand2, vec2(s, t));\n" // kernel value
	"            vec4 v_sample = texture2D(operand1, v_inner_texcoord);\n" // sample value
	"            v_out += v_kernel * v_sample;\n"
	"            v_inner_texcoord.x += v_offset.x;\n"
	"        }\n"
	"        v_texcoord.y += v_offset.y;\n"
	"    }\n"
	"    gl_FragColor = v_out;\n"
	"}\n", "operand1|operand2");
// 2D convolution shader (doesn't necessarily lead to alpha = 1)

TShaderInfo convolution_cmplxi_rek_2D_shader("convolution_cmplxi_rek_2D_shader", true,
	"uniform sampler2D operand1, operand2;\n"
	"uniform vec2 v_offset, v_origin;\n"
	"uniform int n_kernel_w, n_kernel_h;\n"
	"varying vec2 v_kernel_step;\n" // needs k2d_cs_shader to fill this up
	"void main()\n"
	"{\n"
	"    vec2 v_texcoord = gl_TexCoord[0].xy + v_origin;\n"
	"    vec2 v_out = vec2(0, 0);\n"
	"    float t = .0;\n"
	"    for(int j = 0; j < n_kernel_h; ++ j, t += v_kernel_step.y) {\n"
	"        vec2 v_inner_texcoord = v_texcoord;\n" // inner loop needs it's own texcoord
	"        float s = .0;\n"
	"        for(int i = 0; i < n_kernel_w; ++ i, s += v_kernel_step.x) {\n"
	"            float f_kernel = texture2D(operand2, vec2(s, t)).x;\n" // real kernel value
	"            vec2 v_sample = texture2D(operand1, v_inner_texcoord).xw;\n" // complex sample value
	"            v_out += f_kernel * v_sample;\n"
	"            v_inner_texcoord.x += v_offset.x;\n"
	"        }\n"
	"        v_texcoord.y += v_offset.y;\n"
	"    }\n"
	"    gl_FragColor = v_out.xxxy;\n"
	"}\n", "operand1|operand2");
// 2D convolution complex image, real kernel shader (doesn't necessarily lead to alpha = 1)

TShaderInfo convolution_rei_cmplxk_2D_shader("convolution_rei_cmplxk_2D_shader", true,
	"uniform sampler2D operand1, operand2;\n"
	"uniform vec2 v_offset, v_origin;\n"
	"uniform int n_kernel_w, n_kernel_h;\n"
	"varying vec2 v_kernel_step;\n" // needs k2d_cs_shader to fill this up
	"void main()\n"
	"{\n"
	"    vec2 v_texcoord = gl_TexCoord[0].xy + v_origin;\n"
	"    vec2 v_out = vec2(0, 0);\n"
	"    float t = .0;\n"
	"    for(int j = 0; j < n_kernel_h; ++ j, t += v_kernel_step.y) {\n"
	"        vec2 v_inner_texcoord = v_texcoord;\n" // inner loop needs it's own texcoord
	"        float s = .0;\n"
	"        for(int i = 0; i < n_kernel_w; ++ i, s += v_kernel_step.x) {\n"
	"            vec2 v_kernel = texture2D(operand2, vec2(s, t)).xw;\n" // complex kernel value
	"            float f_sample = texture2D(operand1, v_inner_texcoord).x;\n" // real sample value
	"            v_out += v_kernel * f_sample;\n"
	"            v_inner_texcoord.x += v_offset.x;\n"
	"        }\n"
	"        v_texcoord.y += v_offset.y;\n"
	"    }\n"
	"    gl_FragColor = v_out.xxxy;\n"
	"}\n", "operand1|operand2");
// 2D convolution real image, complex kernel shader (doesn't necessarily lead to alpha = 1)

TShaderInfo convolution_cmplx2_2D_shader("convolution_cmplx2_2D_shader", true,
	"uniform sampler2D operand1, operand2;\n"
	"uniform vec2 v_offset, v_origin;\n"
	"uniform int n_kernel_w, n_kernel_h;\n"
	"varying vec2 v_kernel_step;\n" // needs k2d_cs_shader to fill this up
	"void main()\n"
	"{\n"
	"    vec2 v_texcoord = gl_TexCoord[0].xy + v_origin;\n"
	"    vec2 v_out = vec2(0, 0);\n"
	"    float t = .0;\n"
	"    for(int j = 0; j < n_kernel_h; ++ j, t += v_kernel_step.y) {\n"
	"        vec2 v_inner_texcoord = v_texcoord;\n" // inner loop needs it's own texcoord
	"        float s = .0;\n"
	"        for(int i = 0; i < n_kernel_w; ++ i, s += v_kernel_step.x) {\n"
	"            vec2 v_kernel = texture2D(operand2, vec2(s, t)).xw;\n" // complex kernel value
	"            vec3 v_sample; v_sample.xy = texture2D(operand1, v_inner_texcoord).xw;\n" // complex sample value
	"            v_sample.z = -v_sample.y;\n"
	"            v_out += vec2(dot(v_kernel, v_sample.xz), dot(v_kernel, v_sample.yx));\n" // cmplx1 * cmplx2 = re1 * re2 - im1 * im2 + j(im1 * re2 + im2 * re1)
	"            v_inner_texcoord.x += v_offset.x;\n"
	"        }\n"
	"        v_texcoord.y += v_offset.y;\n"
	"    }\n"
	"    gl_FragColor = v_out.xxxy;\n"
	"}\n", "operand1|operand2");
// 2D convolution complex image, complex kernel shader (doesn't necessarily lead to alpha = 1)

TShaderInfo fft_cmplx_x_shader("fft_cmplx_x_shader", true,
	"uniform sampler2D src;\n"
	"uniform sampler1D index, weight;\n"
	"void main()\n"
	"{\n"
	"    vec2 v_index = texture1D(index, gl_TexCoord[0].xy).xw;\n"
	"    vec2 v_weight = texture1D(weight, gl_TexCoord[0].xy).xw;\n"
	"    vec2 v_in0 = texture2D(src, vec2(v_index.x, gl_TexCoord[0].y)).xw;\n"
	"    vec2 v_in1 = texture2D(src, vec2(v_index.y, gl_TexCoord[0].y)).xw;\n"
	"\n"
	"    vec2 v_out = vec2(v_in0.x + v_weight.x * v_in1.x - v_weight.y * v_in1.y,\n"
	"                      v_in0.y + v_weight.y * v_in1.x + v_weight.x * v_in1.y)\n" // butterfly
	"\n"
	"    gl_FragColor = v_out.xxxy;\n"
	"}\n", "src|index|weight");
// fft_cmplx_x_shader

TShaderInfo fft_red_x_shader("fft_red_x_shader", true,
	"uniform sampler2D src;\n"
	"uniform sampler1D index, weight;\n"
	"void main()\n"
	"{\n"
	"    vec2 v_index = texture1D(index, gl_TexCoord[0].xy).xw;\n"
	"    vec2 v_weight = texture1D(weight, gl_TexCoord[0].xy).xw;\n"
	"    float f_in0 = texture2D(src, vec2(v_index.x, gl_TexCoord[0].y)).x;\n"
	"    vec2 v_in1 = texture2D(src, vec2(v_index.y, gl_TexCoord[0].y)).xw;\n"
	"\n"
	"    vec2 v_out = vec2(f_in0 + v_weight.x * v_in1.x - v_weight.y * v_in1.y,\n"
	"                      v_weight.y * v_in1.x + v_weight.x * v_in1.y)\n" // butterfly
	"\n"
	"    gl_FragColor = v_out.xxxy;\n"
	"}\n", "src|index|weight");
// fft_red_x_shader

TShaderInfo fft_cmplx_y_shader("fft_cmplx_y_shader", true,
	"uniform sampler2D src;\n"
	"uniform sampler1D index, weight;\n"
	"void main()\n"
	"{\n"
	"    vec2 v_index = texture1D(index, gl_TexCoord[0].xy).xw;\n"
	"    vec2 v_weight = texture1D(weight, gl_TexCoord[0].xy).xw;\n"
	"    vec2 v_in0 = texture2D(src, vec2(gl_TexCoord[0].x, v_index.x)).xw;\n"
	"    vec2 v_in1 = texture2D(src, vec2(gl_TexCoord[0].x, v_index.y)).xw;\n"
	"\n"
	"    vec2 v_out = vec2(v_in0.x + v_weight.x * v_in1.x - v_weight.y * v_in1.y,\n"
	"                      v_in0.y + v_weight.y * v_in1.x + v_weight.x * v_in1.y)\n" // butterfly
	"\n"
	"    gl_FragColor = v_out.xxxy;\n"
	"}\n", "src|index|weight");
// fft_cmplx_y_shader

/**
 *	bool Register_Shaders()
 *		- registers shader source codes with shader names to CShaderFactory
 *		- returns true on success, false on failure (not enough memory to hold shader list)
 */
bool Register_Shaders()
{
	/*if(!CShaderFactory::Register_ShaderSource("|my_test_shader", 0, &my_test_shader))
		return false;

	if(!CShaderFactory::Register_ShaderSource("|my_test_shader2", 0, &my_test_shader2))
		return false;*/ // test shaders only

	if(!CShaderFactory::Register_ShaderSource("|greyscale_shader", 0, &greyscale_shader))
		return false;

	if(!CShaderFactory::Register_ShaderSource("|color-matrix_shader", 0, &color_matrix_shader))
		return false;

	if(!CShaderFactory::Register_ShaderSource("|threshold_shader", 0, &threshold_shader))
		return false;

	if(!CShaderFactory::Register_ShaderSource("|invert_shader", 0, &invert_shader))
		return false;

	if(!CShaderFactory::Register_ShaderSource("|mult_shader", 0, &mult_shader))
		return false;

	if(!CShaderFactory::Register_ShaderSource("|mult_cmplx2_shader", 0, &mult_cmplx2_shader))
		return false;

	if(!CShaderFactory::Register_ShaderSource("|mult_cmplx_re_shader", 0, &mult_cmplx_re_shader))
		return false;

	if(!CShaderFactory::Register_ShaderSource("|divide_shader", 0, &divide_shader))
		return false;

	if(!CShaderFactory::Register_ShaderSource("|divide_cmplx2_shader", 0, &divide_cmplx2_shader))
		return false;

	if(!CShaderFactory::Register_ShaderSource("|divide_cmplx_re_shader",
	   0, &divide_cmplx_re_shader))
		return false;

	if(!CShaderFactory::Register_ShaderSource("|divide_re_cmplx_shader",
	   0, &divide_re_cmplx_shader))
		return false;

	if(!CShaderFactory::Register_ShaderSource("|subtract_shader", 0, &subtract_shader))
		return false;

	if(!CShaderFactory::Register_ShaderSource("|blend_shader", 0, &blend_shader))
		return false;

	if(!CShaderFactory::Register_ShaderSource("|blend_shader2", 0, &blend_shader2))
		return false;

	if(!CShaderFactory::Register_ShaderSource("|log_shader", 0, &log_shader))
		return false;

	if(!CShaderFactory::Register_ShaderSource("|sqrt_shader", 0, &sqrt_shader))
		return false;

	if(!CShaderFactory::Register_ShaderSource("|exp_shader", 0, &exp_shader))
		return false;

	if(!CShaderFactory::Register_ShaderSource("|pow_shader", 0, &pow_shader))
		return false;

	if(!CShaderFactory::Register_ShaderSource("|abs_shader", 0, &abs_shader))
		return false;

	if(!CShaderFactory::Register_ShaderSource("|scale_shader", 0, &scale_shader))
		return false;

	if(!CShaderFactory::Register_ShaderSource("|point_min_shader", 0, &point_min_shader))
		return false;

	if(!CShaderFactory::Register_ShaderSource("|point_max_shader", 0, &point_max_shader))
		return false;

	if(!CShaderFactory::Register_ShaderSource("ps_calc_shader|bicubic_shader",
	   &ps_calc_shader, &bicubic_shader))
		return false;

	if(!CShaderFactory::Register_ShaderSource("|sep_mean_shader", 0, &sep_mean_shader))
		return false;

	if(!CShaderFactory::Register_ShaderSource("|sep_median3_shader", 0, &sep_median3_shader))
		return false;

	if(!CShaderFactory::Register_ShaderSource("|sep_median5_shader", 0, &sep_median5_shader))
		return false;

	if(!CShaderFactory::Register_ShaderSource("|sep_median7_shader", 0, &sep_median7_shader))
		return false;

	if(!CShaderFactory::Register_ShaderSource("|sep_median15_shader", 0, &sep_median15_shader))
		return false;

	if(!CShaderFactory::Register_ShaderSource("|sep_local_min_shader", 0, &sep_local_min_shader))
		return false;

	if(!CShaderFactory::Register_ShaderSource("|sep_local_max_shader", 0, &sep_local_max_shader))
		return false;

	if(!CShaderFactory::Register_ShaderSource("|erode_square_shader", 0, &erode_square_shader))
		return false;

	if(!CShaderFactory::Register_ShaderSource("|dilate_square_shader", 0, &dilate_square_shader))
		return false;

	if(!CShaderFactory::Register_ShaderSource("|erode_diamond_shader", 0, &erode_diamond_shader))
		return false;

	if(!CShaderFactory::Register_ShaderSource("|dilate_diamond_shader", 0, &dilate_diamond_shader))
		return false;

	if(!CShaderFactory::Register_ShaderSource("k2d_cs_shader|erode_image_shader",
	  &k2d_cs_shader, &erode_image_shader))
		return false;

	if(!CShaderFactory::Register_ShaderSource("k2d_cs_shader|dilate_image_shader",
	  &k2d_cs_shader, &dilate_image_shader))
		return false;

	if(!CShaderFactory::Register_ShaderSource("k2d_cs_shader|morph_hitmiss_shader",
	  &k2d_cs_shader, &morph_hitmiss_shader))
		return false;

	if(!CShaderFactory::Register_ShaderSource("k1d_cs_shader|convolution_separable_shader",
	  &k1d_cs_shader, &convolution_separable_shader))
		return false;

	if(!CShaderFactory::Register_ShaderSource(
	  "k1d_cs_shader|convolution_cmplxi_rek_separable_shader",
	  &k1d_cs_shader, &convolution_cmplxi_rek_separable_shader))
		return false;

	if(!CShaderFactory::Register_ShaderSource(
	  "k1d_cs_shader|convolution_rei_cmplxk_separable_shader",
	  &k1d_cs_shader, &convolution_rei_cmplxk_separable_shader))
		return false;

	if(!CShaderFactory::Register_ShaderSource(
	  "k1d_cs_shader|convolution_cmplx2_separable_shader",
	  &k1d_cs_shader, &convolution_cmplx2_separable_shader))
		return false;

	if(!CShaderFactory::Register_ShaderSource(
	  "k2d_cs_shader|convolution_2D_shader", &k2d_cs_shader, &convolution_2D_shader))
		return false;

	if(!CShaderFactory::Register_ShaderSource(
	  "k2d_cs_shader|convolution_cmplxi_rek_2D_shader",
	  &k2d_cs_shader, &convolution_cmplxi_rek_2D_shader))
		return false;

	if(!CShaderFactory::Register_ShaderSource(
	  "k2d_cs_shader|convolution_rei_cmplxk_2D_shader",
	  &k2d_cs_shader, &convolution_rei_cmplxk_2D_shader))
		return false;

	if(!CShaderFactory::Register_ShaderSource(
	  "k2d_cs_shader|convolution_cmplx2_2D_shader", &k2d_cs_shader, &convolution_cmplx2_2D_shader))
		return false;

	if(!CShaderFactory::Register_ShaderSource("|fft_cmplx_x_shader", 0, &fft_cmplx_x_shader))
		return false;

	if(!CShaderFactory::Register_ShaderSource("|fft_red_x_shader", 0, &fft_red_x_shader))
		return false;

	if(!CShaderFactory::Register_ShaderSource("|fft_cmplx_y_shader", 0, &fft_cmplx_y_shader))
		return false;

	return true;
}

/*
 *		-end-of-file-
 */
